<?php
namespace Teknisa\FAI\Modules\Tabelas\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DataSource\DataSet;
use Zeedhi\Framework\DataSource\FilterCriteria;

class Fai00700ClientesPorFilial extends \Teknisa\GER\Controllers\TeknisaCrud {

	protected $dataSourceNameToSave = 'clienfilial';
	protected $parameterBagColumns = array('CDFILIAL', 'NRORG');
	protected $dataSourceName = 'fai00700_clienfilial_cliente';
	protected $connection;
	protected $crudService;
	protected $parameterBag;

	public function __construct($crudService, $parameterBag, $connection) {
		$this->crudService = $crudService;
		$this->parameterBag = $parameterBag;
		$this->connection = $connection;
	}

	public function save(DTO\Request $request, DTO\Response $response){
		$row = $request->getDataSet()->getRows()[0];
		if($row['IDCLIENPRIN'] == 'S'){
			$this->changeClientePrincipal($row, $request, $response);
		}
		parent::save($request, $response);
	}

	private function changeClientePrincipal($row, $request, $response){
		$row = $request->getDataSet()->getRows()[0];
		$clientePrincipal = $this->getClienteFilial($row);
		if(!empty($clientePrincipal)){
			$clientePrincipal['IDCLIENPRIN'] = 'N';
			$clientePrincipal['__is_new'] = false;
			$clientePrincipal['changed'] = true;
			$dataSet = new DataSet('clienfilial', array($clientePrincipal));
			$newRequest = new DTO\Request\DataSet($dataSet, $request->getMethod(), $request->getRoutePath(), $request->getUserId());
			parent::save($newRequest, $response);
		}
	}

	private function getClienteFilial($row){
		$conditions = array(
			array(
				'columnName' => 'CDFILIAL',
				'operator' => '=',
				'value' => $row['CDFILIAL']
			),
			array(
				'columnName' => 'NRORG',
				'operator' => '=',
				'value' => $row['__is_new'] ? $this->crudService->getEnvironment()->getNrOrg() : $row['NRORG']
			),
			array(
				'columnName' => 'IDCLIENPRIN',
				'operator' => '=',
				'value' => 'S'
			)
		);
		$clientePrincipal = $this->crudService->getFilteredDataSet('clienfilial', $conditions)->getRows();
		if(empty($clientePrincipal)){
			return false;
		} else {
			return $clientePrincipal[0];
		}
	}
}